#include <string.h>
#include "m2.h"

int Initialize_M(ContextM *m)
{
   memset(m, 0, sizeof(ContextM));
}

int Execute_M(ContextM *m, int *err)
{
   unsigned char *cip = m->bytecode;
   unsigned char reg;
   char reg_a;
   char reg_b;
   m->err = 0;
   while (!m->err)
   {
      switch (*cip++)
      {
         case OP_ADD:
            reg_a += reg_b;
	    break;
	 case OP_MUL:
            reg_a *= reg_b; 
	    break;
	 case OP_SET:
            reg = *cip++;
            if (reg == REG_A)
               reg_a = *cip++;
	    else
               reg_b = *cip++;
	    break;
	 case OP_END:
            m->err = ERR_HALT;
	    break;
      }
   }

   if (err)
      *err = m->err;

   /* return register A as output */
   return m->regs[REG_A];
}

